<script lang="ts">
  import type { User, UUID } from '$lib/graphql/types';
  import {
    UserByIdStore,
    UserParticipationHistoryByIdStore,
    type UserParticipationHistoryById$result,
  } from '$houdini';
  import { Tooltip } from "flowbite-svelte";
  import Fa from 'svelte-fa';
  import { faDiscord } from '@fortawesome/free-brands-svg-icons';
  import { faScroll, faGlobe, faBolt, faTrophy, faEnvelope } from '@fortawesome/free-solid-svg-icons';
  import FaIndicator from '$lib/components/ui-elements/FaIndicator.svelte';

  type Input = {
    user_id: UUID;
    user?: User | null;
  };

  export let user: Input | null;
  export let hideEmail: boolean = false;
  export let hideDiscord: boolean = false;
  export let hideStats: boolean = false;
  // Generate a unique id for this element
  const instanceID = Math.floor(Math.random() * 1000);

  $: userStore = new UserByIdStore();
  $: userStore.subscribe((data) => {
    if (data.errors?.length) console.error('Failed to fetch user by id', data.errors);
  });
  $: userHistoryStore = new UserParticipationHistoryByIdStore();
  $: userHistoryStore.subscribe((data) => {
    if (data.errors?.length) console.error('Failed to fetch user history by id', data.errors);
  });

  async function getUser(): Promise<{user: Partial<User>, history: UserParticipationHistoryById$result | null}> {
    // If we were passed a user, don't fetch user data
    let userRet = null;
    if (!user?.user) {
      if (!user?.user_id) throw new Error('No user id provided');

      const userResponse = await userStore.fetch({ variables: { user_id: user.user_id } });

      if (userResponse.errors?.length) {
        console.error('Failed to fetch user by id', userResponse.errors);
        throw new Error(`Failed to fetch user by id`);
      }

      userRet = { email: user?.user_id };

      if (!userResponse.data?.c2games_user_by_pk) {
        console.error('no user data was returned');
      } else {
        userRet = userResponse.data?.c2games_user_by_pk;
      }
    } else {
      userRet = user.user;
    }

    const historyResponse = await userHistoryStore.fetch({ variables: { user_id: user.user_id } });

    if (historyResponse.errors?.length) {
      console.error('Failed to fetch user history by id', historyResponse.errors);
    }

    return {user: userRet, history: historyResponse.data || null};
  }
</script>

{#await getUser()}
  <p>Loading User Info...</p>
{:then userData}
  <div class="flex flex-nowrap items-center">
    <span class="flex flex-nowrap">
      {userData.user.first_name || ''}
      {userData.user.last_name || ''}
    </span>
    <div class="flex flex-nowrap gap-x-1 px-2 items-center">
      {#if !hideDiscord}
        <div>
          <span id="discord-linked-{instanceID}-{userData.user.id}">
            <Fa icon={faDiscord} class='{userData.user.discord_linked ? "text-discord-purple" : "text-gray-400"} w-4 h-4' />
          </span>
          <div class="absolute text-nowrap">
            <Tooltip triggeredBy="#discord-linked-{instanceID}-{userData.user.id}">{userData.user.discord_linked ? userData.user.discord_username : "Discord not linked"}</Tooltip>
          </div>
        </div>
      {/if}
      {#if !hideStats}
        {#if userData.history?.regionals?.aggregate?.count && userData.history?.regionals?.nodes?.length > 0}
          <div>
            <span id="user-regional-history-{instanceID}-{userData.user.id}">
              <FaIndicator icon={faGlobe} count={userData.history?.regionals?.aggregate?.count} />
            </span>
            <div class="absolute text-nowrap">
              <Tooltip triggeredBy="#user-regional-history-{instanceID}-{userData.user.id}">
                <div class="flex flex-col">
                  {#each userData.history.regionals.nodes as entry}
                    <div>{entry.event.event_group?.name}</div>
                  {/each}
                </div>
              </Tooltip>
            </div>
          </div>
        {/if}
        {#if userData.history?.finals?.aggregate?.count && userData.history?.finals?.nodes?.length > 0}
          <div>
            <span id="user-finals-history-{instanceID}-{userData.user.id}">
              <FaIndicator class="text-yellow-300 w-4 h-4" icon={faBolt} count={userData.history?.finals?.aggregate?.count} />
            </span>
            <div class="absolute text-nowrap">
              <Tooltip triggeredBy="#user-finals-history-{instanceID}-{userData.user.id}">
                <div class="flex flex-col">
                  {#each userData.history.finals.nodes as entry}
                    <div>{entry.event.event_group?.name}</div>
                  {/each}
                </div>
              </Tooltip>
            </div>
          </div>
        {/if}
        {#if userData.history?.awards?.length }
          <div>
            <span id="user-awards-{instanceID}-{userData.user.id}">
              <FaIndicator icon={faTrophy} count={userData.history?.awards?.length} />
            </span>
            <div class="absolute text-nowrap">
              <Tooltip triggeredBy="#user-awards-{instanceID}-{userData.user.id}">
                <div class="flex flex-col">
                  {#each userData.history.awards as award}
                    <div>{award.badge.name}</div>
                  {/each}
                </div>
              </Tooltip>
            </div>
          </div>
        {/if}
      {/if}
    </div>
  </div>
  {#if !hideEmail}
    <div class="flex flex-nowrap items-center justify-end">
      <span class="md:hidden">
        <span
          class="cursor-pointer"
          id="user-email-{instanceID}-{userData.user.id}"
          on:click={() => navigator.clipboard.writeText(userData.user.email || "")}>
          <Fa icon={faEnvelope} />
        </span>
        <Tooltip trigger="click" triggeredBy="#user-email-{instanceID}-{userData.user.id}">
          <div class="flex flex-col">
            Copied {userData.user.email}
          </div>
        </Tooltip>
      </span>
      <span class="max-md:hidden">
        <a class="text-cyber-blue-500" href="mailto:{userData.user.email}">{userData.user.email}</a>
      </span>
    </div>
  {/if}
{:catch error}
  <p class="text-red-600 whitespace-pre-wrap">{error.message}</p>
{/await}
